# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.130
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from helix_platform_api_public_client_legacy.models.business_process_step_block import BusinessProcessStepBlock
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

BUSINESSPROCESSCONTENTBLOCK_ONE_OF_SCHEMAS = ["BusinessProcessForkBlock", "BusinessProcessStepBlock"]

class BusinessProcessContentBlock(BaseModel):
    """
    BusinessProcessContentBlock
    """
    # data type: BusinessProcessForkBlock
    oneof_schema_1_validator: Optional[BusinessProcessForkBlock] = None
    # data type: BusinessProcessStepBlock
    oneof_schema_2_validator: Optional[BusinessProcessStepBlock] = None
    if TYPE_CHECKING:
        actual_instance: Union[BusinessProcessForkBlock, BusinessProcessStepBlock]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(BUSINESSPROCESSCONTENTBLOCK_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = BusinessProcessContentBlock.construct()
        error_messages = []
        match = 0
        # validate data type: BusinessProcessForkBlock
        if not isinstance(v, BusinessProcessForkBlock):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BusinessProcessForkBlock`")
        else:
            match += 1
        # validate data type: BusinessProcessStepBlock
        if not isinstance(v, BusinessProcessStepBlock):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BusinessProcessStepBlock`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> BusinessProcessContentBlock:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> BusinessProcessContentBlock:
        """Returns the object represented by the json string"""
        instance = BusinessProcessContentBlock.construct()
        error_messages = []
        match = 0

        # deserialize data into BusinessProcessForkBlock
        try:
            instance.actual_instance = BusinessProcessForkBlock.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BusinessProcessStepBlock
        try:
            instance.actual_instance = BusinessProcessStepBlock.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into BusinessProcessContentBlock with oneOf schemas: BusinessProcessForkBlock, BusinessProcessStepBlock. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

from helix_platform_api_public_client_legacy.models.business_process_fork_block import BusinessProcessForkBlock
BusinessProcessContentBlock.update_forward_refs()

