# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.130
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from helix_platform_api_public_client_legacy.models.business_process_step_status import BusinessProcessStepStatus

class BusinessProcessStepAttempt(BaseModel):
    """
    BusinessProcessStepAttempt
    """
    status: BusinessProcessStepStatus = Field(...)
    started_at: Optional[datetime] = Field(default=None, alias="startedAt", description="Date and time with zone information, marks an **absolute point** on the timeline  - theoretically can be sent and received with any zone offset (until it marks the desired **absolute point** on the timeline) - in practice it is advised to transfer it in UTC timezone (with Z offset, \"Zulu time\") - ISO 8601 compliant string in `yyyy-mm-ddThh:mm:ss.SSSZ` format ")
    ended_at: Optional[datetime] = Field(default=None, alias="endedAt", description="Date and time with zone information, marks an **absolute point** on the timeline  - theoretically can be sent and received with any zone offset (until it marks the desired **absolute point** on the timeline) - in practice it is advised to transfer it in UTC timezone (with Z offset, \"Zulu time\") - ISO 8601 compliant string in `yyyy-mm-ddThh:mm:ss.SSSZ` format ")
    fail_reason: Optional[StrictStr] = Field(default=None, alias="failReason")
    __properties = ["status", "startedAt", "endedAt", "failReason"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BusinessProcessStepAttempt:
        """Create an instance of BusinessProcessStepAttempt from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BusinessProcessStepAttempt:
        """Create an instance of BusinessProcessStepAttempt from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BusinessProcessStepAttempt.parse_obj(obj)

        _obj = BusinessProcessStepAttempt.parse_obj({
            "status": obj.get("status"),
            "started_at": obj.get("startedAt"),
            "ended_at": obj.get("endedAt"),
            "fail_reason": obj.get("failReason")
        })
        return _obj


