# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.130
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist
from helix_platform_api_public_client_legacy.models.intra_day_nomination_gate import IntraDayNominationGate
from helix_platform_api_public_client_legacy.models.mtu_size import MtuSize

class IntraDayNominationGates(BaseModel):
    """
    IntraDayNominationGates
    """
    nomination_gates: conlist(IntraDayNominationGate) = Field(default=..., alias="nominationGates")
    mtu_size: MtuSize = Field(default=..., alias="mtuSize")
    __properties = ["nominationGates", "mtuSize"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IntraDayNominationGates:
        """Create an instance of IntraDayNominationGates from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in nomination_gates (list)
        _items = []
        if self.nomination_gates:
            for _item in self.nomination_gates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['nominationGates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IntraDayNominationGates:
        """Create an instance of IntraDayNominationGates from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IntraDayNominationGates.parse_obj(obj)

        _obj = IntraDayNominationGates.parse_obj({
            "nomination_gates": [IntraDayNominationGate.from_dict(_item) for _item in obj.get("nominationGates")] if obj.get("nominationGates") is not None else None,
            "mtu_size": obj.get("mtuSize")
        })
        return _obj


