# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.130
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, conint

class ParticipantOverviewDataOrganisationMembers(BaseModel):
    """
    ParticipantOverviewDataOrganisationMembers
    """
    registered_count: conint(strict=True, ge=0) = Field(default=..., alias="registeredCount", description="Natural numbers {0, 1, 2, 3, ...} used for counting elements")
    invited_count: conint(strict=True, ge=0) = Field(default=..., alias="invitedCount", description="Natural numbers {0, 1, 2, 3, ...} used for counting elements")
    __properties = ["registeredCount", "invitedCount"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ParticipantOverviewDataOrganisationMembers:
        """Create an instance of ParticipantOverviewDataOrganisationMembers from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ParticipantOverviewDataOrganisationMembers:
        """Create an instance of ParticipantOverviewDataOrganisationMembers from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ParticipantOverviewDataOrganisationMembers.parse_obj(obj)

        _obj = ParticipantOverviewDataOrganisationMembers.parse_obj({
            "registered_count": obj.get("registeredCount"),
            "invited_count": obj.get("invitedCount")
        })
        return _obj


