# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Helix**, the nomination platform of ElecLink_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/eleclink-helix/platform-api) 

    The version of the OpenAPI document: 0.0.130
    Contact: team.eleclink@eleclink.co.uk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr, validator
from helix_platform_api_public_client_legacy.models.user_organisation import UserOrganisation
from helix_platform_api_public_client_legacy.models.user_role import UserRole
from helix_platform_api_public_client_legacy.models.user_status import UserStatus

class User(BaseModel):
    """
    User
    """
    id: StrictStr = Field(default=..., description="Unique identifier for the record in UUID4 format")
    organisation: UserOrganisation = Field(...)
    name: StrictStr = Field(...)
    email: constr(strict=True) = Field(...)
    phone_number: constr(strict=True) = Field(default=..., alias="phoneNumber")
    role: UserRole = Field(...)
    status: UserStatus = Field(...)
    job_title: Optional[StrictStr] = Field(default=None, alias="jobTitle")
    __properties = ["id", "organisation", "name", "email", "phoneNumber", "role", "status", "jobTitle"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> User:
        """Create an instance of User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of organisation
        if self.organisation:
            _dict['organisation'] = self.organisation.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> User:
        """Create an instance of User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return User.parse_obj(obj)

        _obj = User.parse_obj({
            "id": obj.get("id"),
            "organisation": UserOrganisation.from_dict(obj.get("organisation")) if obj.get("organisation") is not None else None,
            "name": obj.get("name"),
            "email": obj.get("email"),
            "phone_number": obj.get("phoneNumber"),
            "role": obj.get("role"),
            "status": obj.get("status"),
            "job_title": obj.get("jobTitle")
        })
        return _obj


